/****************************************************
          Visual FoxPro
         .., --, 2001
      :
    :          void CreateLink(ParamBlk *parm)
     : void GetLink(ParamBlk *parm)

         VFP  fll-.
     VFP   FoxInfo  FoxTables.
        VFP   :

    :

   cLinkFile   : (in)  -
   cPathName   : (in)   ,    
   :
   cArgs       : (in)   
   cWorkingDir : (in)   
   cIconPath   : (in)    
   nIconIndex  : (in)      
   nShowCmd    : (in)   
   nHotkey     : (in)    
   cDesc       : (in)  
   
   Result:        (0 - ,   )

      

   cLinkFile   : (in)   -
   cPathName   : (out)   ,    
   :
   cArgs       : (out)   
   cWorkingDir : (out)   
   cIconPath   : (out)    
   nIconIndex  : (out)      
   nShowCmd    : (out)   
   nHotkey     : (out)    
   cDesc       : (out)  
   
   Result:        (0 - ,   )

      fll   
*****************************************************/

#include <pro_ext.h>
#include <string.h>
#include <winerror.h>
#include <SHLOBJ.H>

HRESULT NullTerminate(Value *cVal, char **pszString)
{ //  0   ,   VFP
  HRESULT hRes=0;
  if ( _SetHandSize(cVal->ev_handle, cVal->ev_length + 1) )
  { ((char *) _HandToPtr(cVal->ev_handle))[cVal->ev_length] = '\0';
    *pszString = (char *) _HandToPtr(cVal->ev_handle);
  }
  else hRes=E_OUTOFMEMORY; //   0x8007000EL

  return hRes;
}

HRESULT GetLinkFile (ParamBlk *parm, WORD *wszLinkFile)
{ //   " -"
  //   0-,   Unicode
  HRESULT hRes=0;
  char *pszString;

  hRes=NullTerminate(&parm->p[0].val, &pszString);
  if SUCCEEDED(hRes)
  { //   pszString  Unicode.
	_HLock(parm->p[0].val.ev_handle);
    if (MultiByteToWideChar(CP_ACP, 0, pszString, -1, wszLinkFile, _MAX_PATH)==0)
	  hRes=GetLastError();	// ERROR_INSUFFICIENT_BUFFER=122
 	_HUnLock(parm->p[0].val.ev_handle);
  }
  return hRes;
}

// --------------     --------------------

HRESULT SetOutCharPar (Parameter *par, char *pszValue)
{ //    ,   
  HRESULT hRes=0;
  Value val;
  val.ev_type = 'C';
  val.ev_length = strlen(pszValue);
  val.ev_handle = _AllocHand(val.ev_length);
  if (val.ev_handle==0)	return(E_OUTOFMEMORY); //   0x8007000EL

  _HLock(val.ev_handle);
  _MemMove((char *) _HandToPtr( val.ev_handle ), pszValue, val.ev_length);
  hRes=_Store(&par->loc, &val);
  _HUnLock(val.ev_handle);

  _FreeHand(val.ev_handle);
  return(hRes);
}

void SetOutIntPar (Parameter *par, int iValue)
{ //      Integer,   
  Value val;
  val.ev_type = 'I';
  val.ev_width=10;
  val.ev_long = (long)iValue;
  _Store(&par->loc, &val);
}

HRESULT GetLinkAttrs(IShellLink* pIShellLink, ParamBlk *parm)
{ //   
  HRESULT hRes=0;
  WIN32_FIND_DATA wFindData;
  char szString[_MAX_PATH];
  int iValue=0;
  WORD wHotkey;

  //   
  hRes = pIShellLink->GetPath(szString, _MAX_PATH, &wFindData, SLGP_SHORTPATH );
  if (!SUCCEEDED(hRes)) return hRes;
  hRes=SetOutCharPar(&parm->p[1], (char *)&szString);
  if (!SUCCEEDED(hRes)) return hRes;

  //   
  if (parm->pCount<3) return hRes;
  hRes = pIShellLink->GetArguments(szString, _MAX_PATH);
  if (!SUCCEEDED(hRes)) return hRes;
  hRes=SetOutCharPar(&parm->p[2], (char *)&szString);
  if (!SUCCEEDED(hRes)) return hRes;

  //  
  if (parm->pCount < 4) return hRes;
  hRes = pIShellLink->GetWorkingDirectory(szString, _MAX_PATH);
  if (!SUCCEEDED(hRes)) return hRes;
  hRes=SetOutCharPar(&parm->p[3], (char *)&szString);
  if (!SUCCEEDED(hRes)) return hRes;
 
  //        
  if (parm->pCount < 5) return hRes;
  hRes = pIShellLink->GetIconLocation(szString, _MAX_PATH, &iValue);
  if (!SUCCEEDED(hRes)) return hRes;
  hRes=SetOutCharPar(&parm->p[4], (char *)&szString);
  if (!SUCCEEDED(hRes)) return hRes;
  if (parm->pCount >= 6) SetOutIntPar (&parm->p[5], iValue);

  //   
  if (parm->pCount < 7) return hRes;
  hRes = pIShellLink->GetShowCmd (&iValue);
  if (!SUCCEEDED(hRes)) return hRes;
  SetOutIntPar (&parm->p[6], iValue);

  //  
  if (parm->pCount < 8) return hRes;
  hRes = pIShellLink->GetHotkey (&wHotkey);
  if (!SUCCEEDED(hRes)) return hRes;
  SetOutIntPar (&parm->p[7], (int)wHotkey);

  // 
  if (parm->pCount < 9) return hRes;
  hRes = pIShellLink->GetDescription(szString, _MAX_PATH);
  if (!SUCCEEDED(hRes)) return hRes;
  hRes=SetOutCharPar(&parm->p[8], (char *)&szString);

  return hRes;
}

void GetLink(ParamBlk *parm)
//    
/* :
   cLinkFile   : (in)   -
   cPathName   : (out)   ,    
   :
   cArgs       : (out)   
   cWorkingDir : (out)   
   cIconPath   : (out)    
   nIconIndex  : (out)      
   nShowCmd    : (out)   
   nHotkey     : (out)    
   cDesc       : (out)  
   
   Result:        (0 - ,   )
*/
{
  IShellLink* pIShellLink;
  IPersistFile* pIPersistFile;
  HRESULT hRes=0;
  WORD wszLinkFile[_MAX_PATH];

  //    cLinkFile
  hRes=GetLinkFile (parm, (WORD *)&wszLinkFile);
  if (hRes==0)
  { //     IShellLink.
    hRes = CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER,
                          IID_IShellLink, (PVOID *)&pIShellLink);
    if SUCCEEDED(hRes)
	{ //     IPersistFile.
      hRes = pIShellLink->QueryInterface(IID_IPersistFile, (PVOID *)&pIPersistFile);
      if SUCCEEDED(hRes)
	  { //  
        hRes = pIPersistFile->Load(wszLinkFile, STGM_READ);
        if SUCCEEDED(hRes)
          hRes=GetLinkAttrs(pIShellLink, parm);	//   

	    pIPersistFile->Release();	//     IPersistFile
	  }
      pIShellLink->Release();		//     IShellLink
	}
  }
  _RetInt(hRes, 10);
}


// --------------   --------------------

HRESULT SetLinkAttrs(IShellLink* pIShellLink, ParamBlk *parm)
{ //   
  HRESULT hRes=0;
  char *pszString;
  int iValue=0;
  WORD wHotKey;

  //   
  hRes=NullTerminate(&parm->p[1].val, &pszString);
  if (!SUCCEEDED(hRes)) return hRes;
  hRes=pIShellLink->SetPath(pszString);
  if (!SUCCEEDED(hRes)) return hRes;

  //   
  if (parm->pCount < 3) return hRes;
  hRes=NullTerminate(&parm->p[2].val, &pszString);
  if (!SUCCEEDED(hRes)) return hRes;
  hRes = pIShellLink->SetArguments(pszString);
  if (!SUCCEEDED(hRes)) return hRes;

  //  
  if (parm->pCount < 4) return hRes;
  hRes=NullTerminate(&parm->p[3].val, &pszString);
  if (!SUCCEEDED(hRes)) return hRes;
  hRes = pIShellLink->SetWorkingDirectory(pszString);
  if (!SUCCEEDED(hRes)) return hRes;

  //        
  if (parm->pCount < 5) return hRes;
  hRes=NullTerminate(&parm->p[4].val, &pszString);
  if (!SUCCEEDED(hRes)) return hRes;
  if (parm->pCount >= 6)  iValue=parm->p[5].val.ev_long;
  if (strlen(pszString)>0)
  { hRes = pIShellLink->SetIconLocation(pszString, iValue);
    if (!SUCCEEDED(hRes)) return hRes;
  }
  //   
  if (parm->pCount < 7) return hRes;
  iValue=parm->p[6].val.ev_long;
  if (!iValue==0)
  { hRes = pIShellLink->SetShowCmd (iValue);
    if (!SUCCEEDED(hRes)) return hRes;
  }
  //  
  if (parm->pCount < 8) return hRes;
  wHotKey=(WORD)parm->p[7].val.ev_long;
  if (!wHotKey==0)
  {	hRes = pIShellLink->SetHotkey (wHotKey);
    if (!SUCCEEDED(hRes)) return hRes;
  }

  // 
  if (parm->pCount < 9) return hRes;
  hRes=NullTerminate(&parm->p[8].val, &pszString);
  if (!SUCCEEDED(hRes)) return hRes;
  hRes = pIShellLink->SetDescription(pszString);

  return hRes;
}

void CreateLink(ParamBlk *parm)
//  
/* :
   cLinkFile   : (in)  -
   cPathName   : (in)   ,    
   :
   cArgs       : (in)   
   cWorkingDir : (in)   
   cIconPath   : (in)    
   nIconIndex  : (in)      
   nShowCmd    : (in)   
   nHotkey     : (in)    
   cDesc       : (in)  
   
   Result:        (0 - ,   )
*/
{
  IShellLink* pIShellLink;
  IPersistFile* pIPersistFile;
  HRESULT hRes=0;

  WORD wszLinkFile[_MAX_PATH];

  //    cLinkFile
  hRes=GetLinkFile (parm, (WORD *)&wszLinkFile);
  if (hRes==0)
  { //     IShellLink.
    hRes = CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER,
                          IID_IShellLink, (PVOID *)&pIShellLink);
    if SUCCEEDED(hRes)
	{ 
	  hRes=SetLinkAttrs(pIShellLink, parm);	//   

      if SUCCEEDED(hRes)
	  { //     IPersistFile.
        hRes = pIShellLink->QueryInterface(IID_IPersistFile, (PVOID *)&pIPersistFile);
        if SUCCEEDED(hRes)
		{ 
		  hRes = pIPersistFile->Save(wszLinkFile, TRUE); //   

		  pIPersistFile->Release();	//     IPersistFile
		}
	  }
      pIShellLink->Release();		//     IShellLink
	}
  }
  _RetInt(hRes, 10);
}

FoxInfo FLLFoxInfo[] =
{    {"CreateLink", (FPFI) CreateLink, 9 , "CC.C.C.C.N.N.N.C"},
     {"GetLink", (FPFI) GetLink, 9 , "CR.R.R.R.R.R.R.R"},
};

extern "C"
{ FoxTable _FoxTable =
	{(FoxTable *) 0, sizeof(FLLFoxInfo)/sizeof(FoxInfo), FLLFoxInfo
	};
}

/*    fll-   VC++ 6.0: 
 
 1. :
     File\New,   Projects  Win32 DLL 
      ShellLink   
 2.   ShellLink.cpp:
     ShellLink.cpp   
     Project\Add to Project\Files,   ShellLink.cpp
 3.    pro_ext.h  winapims.lib
     Tools\Options,   Directories
     Show directories for  Include files  
      ...\VFP98\API
     Show directories for  Library files  
      ...\VFP98\API
 4.  :
     Project\Settings,
   )   Settings for  Win32 Debug    
   )   C/C++     Category  Code generation,
        Calling convention  __Fastcall
        Use runtime lib  Multithreaded DLL 
   )   Link     Category  General
        Output file name  ShellLink.fll
        Object/library modules  winapims.lib
        Ignore default libs
   )   Settings for  Win32 Release    
        )  )
 5. Fll:
     Build\Set Default Configuration    -
        (     5 )
     Build\ShellLink.fll 
*/
